Program DemoScreen;

{ Purpose....... Demonstrates the use of the following units: screen
  Comments...... None
  Author........ Thayne Breetzke
  Date.......... 31 March 1994                                               }

Uses
  Crt,
  Input,
  Cursor,
  Screen;


Var
  Count     : Byte;
  ScrBuffer : ScrBufferRec;
  CState    : CStateRec;

Begin
  TextAttr := 7;
  SaveCursor(InsertKey,CState);
  CursorOff;
  SaveArea(1,1,80,25,ScrBuffer);
  For Count := 0 to 6 do
    Begin
      ChangeAttr(Count*4+1,Count+1,80-(Count*4),25-Count,0+(7-Count)*16);
      Delay(50)
    end;
  WriteXY(34,13,'Press a key...',7+1*16+128);
  WaitForKeypress;
  For Count := 1 to 13 do
    Begin
      ScrollUp(1,1,80,13,1,7);
      ScrollDown(1,13,80,25,1,7);
      ScrollRight(40,1,80,25,1,7);
      ScrollLeft(1,1,39,25,1,7);
      Delay(5)
    end;
  RestoreArea(ScrBuffer);
  RestoreCursor(CState);
  Writeln('Display type   = ',DisplayType,' (',DisplayTypeDesc(DisplayType),')');
  Writeln('Video mode     = ',VideoMode,' (',VideoModeDesc(VideoMode),')');
  Writeln('Rows on screen = ',RowsOnScreen);
  Writeln('Cols on screen = ',ColsOnScreen);
end.